@rem = '--*-Perl-*--
@echo off
if "%OS%" == "Windows_NT" goto WinNT
perl -x -S "%0" %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
:WinNT
perl -x -S %0 %*
if NOT "%COMSPEC%" == "%SystemRoot%\system32\cmd.exe" goto endofperl
if %errorlevel% == 9009 echo You do not have Perl in your PATH.
if errorlevel 1 goto script_failed_so_exit_with_non_zero_val 2>nul
goto endofperl
@rem ';
#!/usr/bin/perl -w
#line 15

#
# ps2text.bat & ps2text.pl
# Copyright (C) 2004 AKANEIROSOFTWARE Tadamasa Teranishi, All rights reserved.
#
# * This program extracts and arranges text string painted by 'show' operators
#   in a PostScript file.
# * This program needs ghostscript(gs)
#
# Original Version
# ps2text (c) Masahiro Kajiura (masahiro.kajiura@toshiba.co.jp)
#

use strict;
use English;
use IO::File;

my $GS = '/usr/bin/gs';
my $PS2TXTPS = '/usr/local/lib/ps2text/ps2txt.ps';
my $PS2TXTBIN = '/usr/local/lib/ps2text/ps2txt';
if ($English::OSNAME eq 'MSWin32') {
    $GS = 'gswin32c.exe';
    $PS2TXTPS = 'C:/usr/local/lib/ps2text/ps2txt.ps';
    $PS2TXTBIN = 'C:/usr/local/lib/ps2text/ps2txt.exe';
}

my $VERSION = 'ps2text for Windows Ver. 1.0.0.1 
Copyright (C) 2004 AKANEIROSOFTWARE Tadamasa Teranishi, All rights reserved.

ps2text  Ver. 0.4.1               (c) Masahiro Kajiura';


my $ORIENT = '-p';
my $TEXENCODING = undef;
my @OPT;
my $FILES = '-';
my $status = 0;

my $USAGE = '
Usage: ps2text [-a] [-{p|l|s|u}] [-iso] [-t|-tt] [-h] [-help] [-v] [filenames]
	-a		not display kanji for symbols
	-p		portrait (default)
	-l		landscape
	-s		seascape
	-u		upside-down
	-iso		use ISOLatin1Encoding
	-t		override TeX \rm encoding onto 0x00--0x7f
	-tt		override TeX \tt encoding onto 0x00--0x7f
	-v		show version
	-h, -help	show this message
';

foreach my $opt (@ARGV) {
    if ($opt eq "-a") {
        @OPT = (@OPT, "-DASCIIONLY");
    } elsif ($opt =~ /^-[plsu]$/) {
        $ORIENT = $opt;
    } elsif ($opt eq "-iso") {
        @OPT = (@OPT, "-DUSE_ISO");
    } elsif ($opt eq "-t") {
        $TEXENCODING = '-DTEXENCODING';
    } elsif ($opt eq "-tt") {
        $TEXENCODING = '-DTEXTTENCODING';
    } elsif ($opt eq "-v") {
        print "$VERSION\n";
        exit 0;
    } elsif ($opt eq "-h" || $opt eq "-help") {
        print STDERR "$USAGE\n";
        exit 0;
    } elsif ($opt =~ /^-/) {
        print "Unknown option -- $opt\n";
        print STDERR "$USAGE\n";
        exit 1;
    } else {
        $FILES = $opt;
        last;
    }
}

if ($ORIENT eq "-p") {
    @OPT = (@OPT, "-DORIENTATION=/Portrait");
} elsif ($ORIENT eq "-l") {
    @OPT = (@OPT, "-DORIENTATION=/Landscape");
} elsif ($ORIENT eq "-s") {
    @OPT = (@OPT, "-DORIENTATION=/Seascape");
} elsif ($ORIENT eq "-u") {
    @OPT = (@OPT, "-DORIENTATION=/Upsidedown");
}

@OPT = (@OPT, "$TEXENCODING") if (defined $TEXENCODING);

my @cmd = (
    "$GS", "-DNODISPLAY", @OPT, "-q", "$PS2TXTPS", "$FILES", "quit.ps"
);

my $fh = new IO::File;
if ($fh->open("| $PS2TXTBIN")) {
    my $saveout = new IO::File (">&" . STDOUT->fileno()) or die "Can't dup STDOUT: $!";
    STDOUT->fdopen($fh->fileno(), 'w') or die "Can't open fh_out: $!";

    $status = system { $cmd[0] } @cmd;

    STDOUT->fdopen($saveout->fileno(), 'w') or die "Can't restore saveout: $!";
    $fh->close;
}

exit $status;

__END__
:endofperl
